use context essentials2021

# A more realistic rumor mill, where each gossip can tell any number of other people -- i.e., an arbitrary tree


data Gossip:
  | gossip(name :: String, next :: List<Gossip>)
end


#|
fun gossip-template(g :: Gossip) -> ...:
  doc: "Template for a function that takes a gossip"
  ... gossip.name
  ... log-template(g.next)
where:
  gossip-template(...) is ...
end

fun log-template(l :: List<Gossip>) -> ...:
  doc: "Template for a function that takes a list of gossip"
  cases (List) l:
    | empty => ...
    | link(f, r) =>
      ... gossip-template(f)
      ... log-template(r)
  end
where:
  log-template(...) is ...
end
|#


GINNY-GOSSIP =
  gossip("Ginny", 
    [list: ])

ROMILDA-GOSSIP =
  gossip("Romilda", 
    [list: GINNY-GOSSIP])

VINCENT-GOSSIP =
  gossip("Vincent", 
    [list: ])

DRACO-GOSSIP =
  gossip("Draco", 
    [list: VINCENT-GOSSIP])

CHO-GOSSIP =
  gossip("Cho", 
    [list: ])

PANSY-GOSSIP =
  gossip("Pansy", 
    [list: DRACO-GOSSIP, CHO-GOSSIP, ROMILDA-GOSSIP])
