use context essentials2021

data RumorMill:
  | no-one
  | gossip(name :: String, next1 :: RumorMill, next2 :: RumorMill)
end


#|
fun rumor-mill-template(rm :: RumorMill) -> ...:
  doc: "Template for a function with a RumorMill as input"
  cases (RumorMill) rm:
    | no-one => ...
    | gossip(name, n1, n2) =>
      ... name
      ... rumor-mill-template(n1)
      ... rumor-mill-template(n2)
  end
where:
  rumor-mill-remplate(...) is ...
end
|#


# An example rumor mill for Ginny to hear about Harry's supposed hypogriff tattoo. This could be given as a single definition, but, as in the slides, I've given names to the parts to make it easier to type and to use sub-trees for testing.

GINNY-MILL = gossip("Ginny", no-one, no-one)
ROMILDA-MILL = gossip("Romilda", no-one, GINNY-MILL)
VINCENT-MILL = gossip("Vincent", no-one, no-one)
DRACO-MILL = gossip("Draco", ROMILDA-MILL, VINCENT-MILL)
CHO-MILL = gossip("Cho", no-one, no-one)
PANSY-MILL = gossip("Pansy", CHO-MILL, DRACO-MILL)
